#if !defined(CLIVINGOBJECT____INCLUDED_)
	#define CLIVINGOBJECT____INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "../../MyFrameAl5/Game/LivingObj.h"
#include "../../MyFrameAl5/Game/ListLivingObject.h"
#include "../../MyFrameAl5/Game/Bullet.h"
#include "../../MyFrameAl5/Stat/Score.h"
#include "GlobalDefs.h"


#define OBJTYPE_PLAYERPOD			60
#define OBJTYPE_ASTEROID			66
#define OBJTYPE_MYEXPLOSION			67
#define OBJTYPE_PLAYERMISSILE		68


//
//#ifdef _DEBUG
//	#define PLAYERREADY_ANIMTIMEOUT			60
//	#define GAMEOVER_ANIMTIMEOUT			150
//	#define PAGEWARNING_TIME				120
//#else
//	#define PLAYERREADY_ANIMTIMEOUT			180	
//	#define GAMEOVER_ANIMTIMEOUT			48
//	#define PAGEWARNING_TIME				500
//#endif



#define PLAYER_NB_LIVES_BEGIN				3
#define PLAYER_EXPLODERESPAWN_TIME			2 // 120
#define PLAYER_KILLED_INVINCIBILITY_TIME	2 // 120
#define PLAYER_COLL_W						48
#define PLAYER_COLL_H						16
#define PLAYER_SPR_W						48
#define PLAYER_SPR_H						32

//#define PLAYER_OFFSET_X						8
//#define PLAYER_OFFSET_Y						-8
//#define PLAYER_DX							4.0f
//
//#define PLAYER_JUMP_PEAKTIME				40
//#define PLAYER_JUMP_PEAK_H					100
////#define PLAYER_JUMP_
//


#define PLAYER_INIT_Y						412


/*--- enemy ---------------------------------------------------------------*/



#define BLOC_SPR_W				32.0f

/*--- background ----------------------------------------------------------*/

#define LIMITWALL_XMIN			(CASTLEENEMY_XMIN - 128)
#define LIMITWALL_XMAX			(CASTLEENEMY_XMAX + 128)
#define WALL_SPR_W				32



// ExternalId's
#define EXTERNALID_PLAYER1			1
#define EXTERNALID_PLATFORM0		1000



/*--- unused stuff --------------------------------------------------------*/

#define COMBO_MULTIPLY_PART1		10
#define COMBO_MULTIPLY_MAX			64
#define COMBO_HITPART				10
#define COMBO_HITMAX				50


//void ConvertXYIntoGridPos(float fx, float fy, char& nCol, char& nRow);
//void ConvertGridPosIntoXY(char m_nTileCol, char m_nTileRow, float& m_fX, float& m_fY);
//bool IsPosEmpty(char nTileCol, char nTileRow);





class CMyLivingObject;    // predeclaraction class

class CMyLivingObject : public CLivingObject
{
public:
	float m_fOriginalX;
	//bool m_bLookLeft;

protected:
	
public: 
	CMyLivingObject();    
    virtual ~CMyLivingObject(); 

	void InitPlayerProps(char nJoypadNum, CLivingObject* pLivingObj);

protected:	
	void OriginalMove();
	void UpdateScreenPos();

public:
	static float ConvertNormalizedToOriginalPos_Ex(float fNormalizedX);
	static float ConvertOriginalToNormalizedPos_Ex(float fOriginalX);

public: 
	virtual bool IsDisposable();
	virtual bool IsCollidable();

	virtual CBullet* V_CreateBullet();
	virtual CBulletWave* V_CreateBulletWave();
	virtual char V_GetLivingObjectDefaultTargetType_Ex(int nOwnerType, int nObjectType);
	

public:
	virtual void SpawnExplosionWhenVanish();	
	virtual void SpawnExplosionWhenHit();	

public:
	virtual void RewardOwner_Kill(CLivingObject* pDeadEntity);
	virtual void RewardOwner_Hit(CLivingObject* pDeadEntity);


};

//////////////////////////////////////////////////////////////////////

#endif // !defined(CLIVINGOBJECT__VESSELDASH__2011_10_26_14_0_34__INCLUDED_)

