#if !defined(_PLAYERENTITY_H____INCLUDED_)
    #define _PLAYERENTITY_H____INCLUDED_

#include "MyLivingObject.h"




#define PLAYER_MOVETRANSITION_MAXTIME		20
#define PLAYER_SKELETON_TOTALITEMS			10
#define PLAYER_SKELETON_ONE_LEG_NBITEMS		5

#define PLAYER_SKELETON_IDLE_TIME			90

#define PLAYER_SKELETON_H					40
#define PLAYER_SKELETON_W					48

#define PLAYER_MYDIRECTION__MASK			0x10



class CPlayerEntity; //predeclaration class

class CPlayerEntity : public CMyLivingObject
{
public: 
	char m_nDirectionLook;
	short m_nIdleMoveTime;
	short m_nWalkAnimTime;
	char m_nMoveTransitionTime; // 0: IDLE.  MAX: WALKING


public: 
    CPlayerEntity(); 
    virtual ~CPlayerEntity(); 

public:

	void InitPlayer();
	//void ResetPos();
	//bool IsJumping();
	//void DoQteCommit(bool bPass);

	virtual int Move();
	static bool IsPressingFire();
	virtual int Draw();
	virtual int DrawOnTop();
	void DrawHUD();
	virtual bool IsDisposable();

	void GetSourceMissile(float& fNormalizedSourceX, float& fNormalizedSourceY);

	//virtual int Suffer(float fHitPoints, bool bForceSuffer, CLivingObject* pOrigin/*=NULL*/);
};




#endif /* _PLAYERENTITY_H__HORRIBLEGJ__2016_11_13__21_17_56__INCLUDED_ */
