/***************************************************************************/
/*                                                                         */
/*                              L A Y O U T                                */
/*                                                                         */
/***************************************************************************/



#include "layout.h"
#include <allegro5/allegro_primitives.h>
#include "MyLivingObject.h"
#include "MyGameHelper.h"
#include "../../MyFrameAl5/Math/MyRand.h"
#include "../../MyFrameAl5/Math/CalcHelper.h"

//void TestDrawLoopSprite()
//{
//	int PERIOD_CLIPX = 120;
//	int PERIOD_CLIPY = 180;
//	int PERIOD_CLIPW = 210;
//	int PERIOD_CLIPH = 230;
//	int PERIOD_LOOPX = 100;
//	int PERIOD_LOOPY = 170;
//	int PERIOD_LOOPW = 70;
//	int PERIOD_LOOPH = 150;
//
//	int t = _pGameHelper->GetCurrentSectionElapsedTime();
//	float CLIPW = 0.3f + 0.4f*CalcAbsTriangle_Int((t+40)%PERIOD_CLIPW, 0, PERIOD_CLIPW);
//	float CLIPH = 0.2f + 0.6f*CalcAbsTriangle_Int((t+90)%PERIOD_CLIPH, 0, PERIOD_CLIPH);
//	float SCALEX = 2.0f;
//	float SCALEY = 3.0f;
//	float fClipX = (1.0-CLIPW)*CalcAbsTriangle_Int(t%PERIOD_CLIPX, 0, PERIOD_CLIPX);
//	float fClipY = (1.0-CLIPH)*CalcAbsTriangle_Int(t%PERIOD_CLIPY, 0, PERIOD_CLIPY);
//
//	CMovieClip* pClip = (CMovieClip*)_pListMovieClips->GetItemByExternalId(MOVIEID_TITLE);
//	
//	//pClip->Draw_RegionPosScale(
//	//	300.0f, 80.0f, 
//	//	fClipX, fClipY, CLIPW, CLIPH, 
//	//	SCALEX, SCALEY);
//
//	float fLoopPosX = 0.99f*CalcAbsTriangle_Int((t/2)%PERIOD_LOOPX, 0, PERIOD_LOOPX); // 0.6f;
//	float fLoopPosY = 0.99f*CalcAbsTriangle_Int((t/2)%PERIOD_LOOPY, 0, PERIOD_LOOPY); // 0.2f;
//	float fLoopW = 0.8f + 2.5f*CalcAbsTriangle_Int((t/3)%PERIOD_LOOPW, 0, PERIOD_LOOPW); // 2.2f;
//	float fLoopH = 0.6f + 1.5f*CalcAbsTriangle_Int((t/3)%PERIOD_LOOPH, 0, PERIOD_LOOPH); // 1.5f
//	float SPRITE_POSX = 320.0f;
//	float SPRITE_POSY = 200.0f;
//	//fClipX = 0.2f;
//	//fClipY = 0.1f;
//	//CLIPW = 0.5f;
//	//CLIPH = 0.7f;
//	SCALEX = 0.6f;
//	SCALEY = 2.0f;
//
//	pClip->Draw_LoopRegionPosScale(
//		SPRITE_POSX, SPRITE_POSY, 
//		fClipX, fClipY, CLIPW, CLIPH, 
//		fLoopPosX, fLoopW, fLoopPosY, fLoopH,
//		SCALEX, SCALEY);
//
//	
//}




/*-------------------------------------------------------------------------*/
/*---------------------------- Draw Test Stuff ----------------------------*/
/*-------------------------------------------------------------------------*/
//void DrawTestStuff()
//{
//	int nCounter = _pGameHelper->GetCurrentSectionElapsedTime();
//	// DrawTitle(0.5f*BITMAP_W, 0.25f*BITMAP_H, 2.0f, 2.0f, 1.5f);
//
//	_pFontNormal->SetMagnify(2.0f, 4.0f);
//
//	float fRot = 1.0f*nCounter;
//	int t = (nCounter%200 <= 100)? (nCounter%100) : 0;
//	float fAlpha = 1.0f - CalcAbsTriangle_Int(t, 0, 100);
//	
//	_pListMovieClips->Draw_W_H_ClipNum(0, 0.1f*BITMAP_W, 0.5f*BITMAP_H, 64, 64, fRot, nCounter, 0, fAlpha, 0.0f, 0.0f, 0.0f, 0.0f);
//
//	DrawMonoQuad4f(0.25f*BITMAP_W, 0.55f*BITMAP_H, 64, 64,  0.0f,1.0f,0.0f, 1.0f);
//	DrawMonoQuad4f(0.45f*BITMAP_W, 0.55f*BITMAP_H, 64, 64,  0.0f,0.5f,0.5f, 1.0f);
//
//	// test alpha
//	_pListMovieClips->Draw_W_H_ClipNum(1, 0.3f*BITMAP_W, 0.5f*BITMAP_H, 64, 64, fRot, nCounter, 0, fAlpha, 0.0f, 0.0f, 0.0f, 0.0f);
//	_pListMovieClips->Draw_W_H_ClipNum(2, 0.5f*BITMAP_W, 0.5f*BITMAP_H, 64, 64, fRot, nCounter, 0, fAlpha, 0.0f, 0.0f, 0.0f, 0.0f);
//	_pListMovieClips->Draw_W_H_ClipNum(3, 0.7f*BITMAP_W, 0.5f*BITMAP_H, 64, 64, fRot, nCounter, 0, fAlpha, 0.0f, 0.0f, 0.0f, 0.0f);
//
//	// test lit
//	float fLit = 1.0f-fAlpha;
//	_pListMovieClips->Draw_W_H_ClipNum(1, 0.3f*BITMAP_W, 0.2f*BITMAP_H, 64, 64, fRot, nCounter, 0, 1.0f, fLit, 1.0f, 0.0f, 0.0f);
//	_pListMovieClips->Draw_W_H_ClipNum(1, 0.5f*BITMAP_W, 0.2f*BITMAP_H, 64, 64, fRot, nCounter, 0, 1.0f, fLit, 0.0f, 1.0f, 0.0f);
//	_pListMovieClips->Draw_W_H_ClipNum(1, 0.7f*BITMAP_W, 0.2f*BITMAP_H, 64, 64, fRot, nCounter, 0, 1.0f, fLit, 0.0f, 0.0f, 1.0f);
//
//	DrawMonoQuad4f(0.65f*BITMAP_W, 0.55f*BITMAP_H, 64, 64,  1.0f,0.0f,0.0f, 0.5f);	
//
//	float fStartX = 0.25f*BITMAP_W;
//	float fStartY = 0.25f*BITMAP_H;
//	DrawMonoQuad4f(fStartX+32, fStartY+32, 64, 64,  0.0f,0.0f,1.0f, 1.0f);	
//	_pFontNormal->PrintVariant(FONTTEXTFMT_STRING, fStartX, fStartY, nCounter%500, "ABCDEFGHIJKLMNO\nabcdefghijklmno\n0123456789!?.(+-)", 0);
//
//	mytextprintf4ub(0.5f*BITMAP_W, 0.75f*BITMAP_H,  255,255,255, 128, "t=%d r=%.3f", nCounter, fRot);
//}

#define TITLE_MAXROWS		8
#define TITLE_MAXCOLS		26


char _szTitleChars[TITLE_MAXROWS][TITLE_MAXCOLS] = {
	  "          00000          "
    , ".000000  00...00 00000.  "
	, ".00  .00 00   .. 00. 00. "
	, ".00  .00 .00000  00.  00."
	, ".000000   ....00 00.  00."
	, ".00  .00 00   00 00.  00."
	, ".00  .00 .00000. 00. 00. "
	, ".00  .00  .....  00000.  "

	/*  
	  " .00000          00000. "
	, ".00   00 00   00     00."
	, ".00      .00 00.     00."
	, " .00000   .000.   0000."
	, "     .00  00 00      00."
	, ".00  .00 00. .00     00."
	, " .00000  ..   .. 00000. "
	*/

	/*
	, "0000  00000  0000 00000"
	, "00 00 00    00      00 "
	, "0000  0000  00      00 "
	, "00 00 00    00      00 "
	, "00 00 00000  0000   00 "
	*/
};

/*-------------------------------------------------------------------------*/
/*------------------------------- Draw Title ------------------------------*/
/*-------------------------------------------------------------------------*/
void DrawTitle()
{
	int t = _pGameHelper->GetCurrentSectionElapsedTime();

	/*--- Brackets --------------------------------------------------------*/

	float fx = (0.6f + 0.34f*CalcCosineDeccel_Int(t, 0, 128))*BITMAP_W;
	float fy = 0.5f*BITMAP_H;
	float fh = 144;
	float fw = 32;
	float fThinW = 16;
	float fAlphaBracket = 0.6f;
	float fDiff = 0.0f; // 16*(1.0f - CalcCosineDeccel_Int(t, 0, 128));

	DrawMonoQuad4f(fx, fy, fThinW, fh,  1.0f, 1.0f, 1.0f, fAlphaBracket);
	DrawMonoQuad4f(fx-0.5f*(fw-fThinW), fy-0.5f*(fh+fThinW+fDiff), fw, fThinW,  1.0f, 1.0f, 1.0f, fAlphaBracket);
	DrawMonoQuad4f(fx-0.5f*(fw-fThinW), fy+0.5f*(fh+fThinW+fDiff), fw, fThinW,  1.0f, 1.0f, 1.0f, fAlphaBracket);

	DrawMonoQuad4f(BITMAP_W - fx, fy, fThinW, fh,  1.0f, 1.0f, 1.0f, fAlphaBracket);
	DrawMonoQuad4f(BITMAP_W - fx+0.5f*(fw-fThinW), fy-0.5f*(fh+fThinW+fDiff), fw, fThinW,  1.0f, 1.0f, 1.0f, fAlphaBracket);
	DrawMonoQuad4f(BITMAP_W - fx+0.5f*(fw-fThinW), fy+0.5f*(fh+fThinW+fDiff), fw, fThinW,  1.0f, 1.0f, 1.0f, fAlphaBracket);

	/*--- Title -----------------------------------------------------------*/

	char nGridX, nGridY;
	unsigned char nCol;
	unsigned char nDiff;
	unsigned char nOscill;
	fw = 8;
	fh = 16;
	float fGapW = 20;
	float fGapH = 28;
	int OSCILL_PERIOD = 65;
	int DIFF_PERIOD = 120;
	float fOffsetX;
	float fOffsetY;
	float fCenterX = 320;
	float fCenterY = BITMAP_H + fGapH;
	//float fOffsetPos;
	int t2;
	float _fx;
	float _fy;

	fy = 64;

	for (nGridY=0; nGridY<TITLE_MAXROWS; nGridY++)
	{
		fy += fGapH;
		fx = 70;

		for (nGridX=0; nGridX<TITLE_MAXCOLS; nGridX++)
		{
			fx += fGapW;

			switch (_szTitleChars[nGridY][nGridX])
			{
			case '0':
				nCol = 255;
				break;

			case '.':
				nCol = 64;
				break;

			default:
				nCol = 0;
			}

			if (nCol > 0)
			{
				nDiff   = 64*CalcAbsTriangle_Int((_nTotalExeTime + 2*nGridX + 4*nGridY)%DIFF_PERIOD, 0, DIFF_PERIOD);
				nOscill = 12*CalcCosineLoop_Int((_nTotalExeTime + 2*nGridX + nGridY )%OSCILL_PERIOD, 0, OSCILL_PERIOD);
				nCol -= nDiff;
				t2 = t + nGridX + nGridY/8;
				fOffsetX = CalcCosineAccel_Int(t2 , 0, 60 + 2*nGridX + 4*nGridY);
				fOffsetY = CalcSquareDeccel_Int(t2, 0, 80 + 4*nGridX +   nGridY);

				_fx = fCenterX + fOffsetX*(fx-fCenterX);
				_fy = fCenterY + fOffsetY*(fy-nOscill-fCenterY);
				DrawMonoQuad4ub(
					  _fx, _fy, fw+8, fh+8
				    , 0,0,0, fOffsetX*128);

				DrawMonoQuad4ub(
					  _fx, _fy, fw, fh
					, nCol,nCol,nCol, 255);
			}
		}
	}
	

}

/*-------------------------------------------------------------------------*/
/*---------------------------- Draw Score List ----------------------------*/
/*-------------------------------------------------------------------------*/
void DrawScoreList(char nGameType)
{
	//if (!(nGameType >= 0 && nGameType < CFG__MAXGAMETYPES))
	//{
	//	return;
	//}

	//char szBuf[256];
	//char i;
	//char nNbNicksDisplay;
	//char nTotalNicks;
	//
	//CStatBlockScoring* pNick;		
	//CListStat* pList;

	//pList = _pListStatScoringScoresByGameMode[ nGameType ];
	// 
	//int nPageElapsedTime = _pGameHelper->GetCurrentSectionElapsedTime();

	//float x	 = 40;				// Rank.Name
	//float y0 = 132.0f;

	//float x1 = x + 288;			// score
	//float x2 = x1 + 64;			// Clear
	//float x3 = x2 + 64;			// Max Combo
	//float x4 = x3 + 30;			// Time


	//float yAdd = 24.0f; 

	//float fTitleScaleY = 2.0f;		// HISHSCORE
	//float fTitleScaleX = 2.0f;
	//float fSubTitleScaleY = 1.25f;	// (Game Type)
	//float fSubTitleScaleX = 1.5f;

	//const char* ptTitle = _pGameHelper->GetGameTypeName(nGameType);

	//// float fNameTimer = CONTRIBUTOR_SLIDETIME;

	//nTotalNicks = pList->GetLength();
	//nNbNicksDisplay = 12;
	//int nRankTarget = pList->GetRankTarget(); // TODO (the rank of the player)

	//float y = 0.0f;
	//float fAlpha;
	//bool bHighlight;
	//float fLit;
	//float fLr, fLg, fLb;
	//float fRot = 0.0f;
	//
	//for (i = 0; i<nTotalNicks && y <= BITMAP_H; i++)
	//{	
	//	pList->HelpDrawScoreItem(i, y, fAlpha, bHighlight, yAdd, nNbNicksDisplay, nRankTarget, nPageElapsedTime);
	//	y += y0;
	//	
	//	if (fAlpha > 0.0f)
	//	{
	//		fLit = 0.0f;
	//		if (bHighlight)
	//		{
	//			fLit = 0.75f*CalcAbsTriangle_Int(nPageElapsedTime%16, 0, 16);

	//			((CGradient*)(_pListGradients->GetItem(GRADNUM_REDSCALE)))->GetColor_3f(
	//				1.0f*(nPageElapsedTime%120)/120,  &fLr, &fLg, &fLb);
	//		}	

	//		pNick = (CStatBlockScoring*)pList->GetItem(i);
	//	
	//		sprintf(szBuf, "%2d. %s", i+1 ,pNick->m_szName );
	//		
	//		_pFontNormal->TextoutClip_Ex(x, y, 999, fRot, fAlpha, fLit, fLr, fLg, fLb, szBuf);						

	//		_pFontNormal->PrintNumberClipInt64_Ex(x1, y, fRot, fAlpha, fLit, fLr, fLg, fLb, 
	//			pNick->m_nScore);
	//		_pFontNormal->PrintNumberClipInt64_Ex(x2, y, fRot, fAlpha, fLit, fLr, fLg, fLb, 
	//			pNick->m_nClears);
	//		_pFontNormal->PrintNumberClipInt64_Ex(x3, y, fRot, fAlpha, fLit, fLr, fLg, fLb, 
	//			pNick->m_nMaxCombo);

	//		_pFontNormal->PrintVariant_Ex(FONTTEXTFMT_TIME_MM_SS_MSEC,
	//			x4, y, 999, fRot, fAlpha, fLit, fLr, fLg, fLb,
	//			NULL, pNick->m_nPlayTime);
	//	}
	//}


	//y = y0;

	//y -= yAdd*1.5f;

	//_pFontNormal->TextoutClip(x+60, y, 999, "Name Score");
	//_pFontNormal->TextoutClip(x2-42, y, 999, "Clr");
	//_pFontNormal->TextoutClip_Ex(x3-42, y, 999, 0.0f, 1.0f, 0.0f, 0,0,0, "MaxCombo");
	//_pFontNormal->TextoutClip(x4, y, 999, "Time");

	//
	//y -= yAdd*fSubTitleScaleY;

	//_pFontNormal->TextoutClip_Ex(
	//	0.5f*BITMAP_W - 0.5f*fSubTitleScaleX*strlen(ptTitle)*_pFontNormal->GetFontW(), 
	//	y, nPageElapsedTime+10, 
	//	//fSubTitleScaleX, fSubTitleScaleY, 
	//	fRot, 1.0f, 
	//	0.0f, 0, 0, 0, 
	//	ptTitle );

	//y -= yAdd*fTitleScaleY;

	//_pFontNormal->TextoutClip_Ex(
	//	0.5f*BITMAP_W - 0.5f*fTitleScaleX*10*_pFontNormal->GetFontW(), 
	//	y , nPageElapsedTime, 
	//	// fTitleScaleX, fTitleScaleY, 
	//	fRot, 1.0f, 
	//	0.0f, 0, 0, 0, 
	//	"HIGHSCORES" );
}





CellInfo_t* GetLitCellAt(char nx, char ny)
{
	ASSERT(nx >= 0 && nx < LITCELLS_MAX_COLS);
	ASSERT(ny >= 0 && ny < LITCELLS_MAX_ROWS);
	return &_nCellLitInfos[ ny*LITCELLS_MAX_COLS + nx ];
}

void SetLitCell_NewMovie(CellInfo_t* pThisCell)
{
	pThisCell->m_nAnimMaxTime = GetRandInt_MinMax(120, 255);
	pThisCell->m_nAnimCurrentTime = pThisCell->m_nAnimMaxTime; 
	pThisCell->m_nAnimMovieNum = rand()%LITCELL_MAXMOVIES;
}

void MoveLitCell(CellInfo_t* pThisCell)
{
	if (pThisCell->m_nAnimCurrentTime > 0)
		pThisCell->m_nAnimCurrentTime--;
	
	if (pThisCell->m_nAnimCurrentTime == 0)
	{
		if ((pThisCell->m_nAnimMovieNum & LITCELL_MOVIENUMFLG_REVERSE) == 0)
		{
			unsigned char nOldMovieNum = pThisCell->m_nAnimMovieNum;
			SetLitCell_NewMovie(pThisCell);
			pThisCell->m_nAnimMovieNum = (nOldMovieNum + 1 + rand()%(LITCELL_MAXMOVIES-1))%LITCELL_MAXMOVIES;
			pThisCell->m_nAnimMovieNum |= LITCELL_MOVIENUMFLG_REVERSE;
			ASSERT(pThisCell->m_nAnimCurrentTime > 0);
		}
	}
}

void AddSpotLitCell()
{
	char nTryCount = 10;
	while (nTryCount > 0)
	{
		nTryCount--;
		
		CellInfo_t* pCell = &_nCellLitInfos[ rand()%LITCELLS_MAX_ITEMS ];
		
		if (pCell->m_nAnimCurrentTime == 0)
		{
			SetLitCell_NewMovie(pCell);
			return;
		}
	}
	
	unsigned short nItemNum;
	nItemNum = rand();
	nTryCount = LITCELLS_MAX_ITEMS/8;
	
	while (nTryCount > 0)
	{
		nTryCount--;
		
		nItemNum++;
		CellInfo_t* pCell = &_nCellLitInfos[ nItemNum%LITCELLS_MAX_ITEMS ];
		
		if (pCell->m_nAnimCurrentTime == 0)
		{
			SetLitCell_NewMovie(pCell);
			return;
		}
	}
}

void MoveLitCells()
{
	unsigned short nItemNum;
	
	for (nItemNum = 0; nItemNum < LITCELLS_MAX_ITEMS ; nItemNum++)
	{
		CellInfo_t* pCell = &_nCellLitInfos[ nItemNum ];
		MoveLitCell(pCell);
	}
	
	
	// Check if it's Time to Add new anim /////////////////////////////////////////////
	
	_nCellLit_NextAdd--;
	if (_nCellLit_NextAdd == 0)
	{		
		_nCellLit_NextAdd = GetRandInt_MinMax(2, 10); // 20, 64);

		int nNbSpots = GetRandInt_MinMax(1, 5);
		while (nNbSpots > 0)
		{
			nNbSpots--;
			AddSpotLitCell();
		}
	}
}

void UpdateLitCells(float fCenterX, float fCenterY, float fRatioX, float fRatioY)
{
	float fx, fy;
	char nx, ny;
	float fMinDist = 64.0f;
	float fSectorW = (0.5f*BITMAP_W - fMinDist)/LITCELL_LITMAX;
	
	fy = 0.5f*LITCELL_SPR_W;
	for (ny=0; ny < LITCELLS_MAX_ROWS; ny++)
	{
		fx = 0.5f*LITCELL_SPR_W;
		
		for (nx=0; nx < LITCELLS_MAX_COLS; nx++)
		{
			CellInfo_t* pThisCell = GetLitCellAt(nx, ny);
			float fDiffX = fRatioX*(fx - fCenterX);
			float fDiffY = fRatioY*(fy - fCenterY);
			float fDist = sqrt(fDiffX*fDiffX + fDiffY*fDiffY) - fMinDist;
			
			//fDist += GetRandFloat_MinMax(-0.8f*fSectorW, 0.8f*fSectorW);

			char nDistCategory = (int)(fDist/fSectorW);
			nDistCategory = CLAMP(0, nDistCategory, LITCELL_LITMAX);
			pThisCell->m_nLitLevel = nDistCategory;
			
			fx += LITCELL_SPR_W;
		}
		
		fy += LITCELL_SPR_W;
	}
}

/*-------------------------------------------------------------------------*/
/*------------------------ Init Lit Cells Sprite Pos ----------------------*/
/*-------------------------------------------------------------------------*/
void InitLitCells_SpritePos()
{
	UpdateLitCells(0.5f*BITMAP_W, 0.5f*BITMAP_H, 1.0f, 1.0f);
	
	unsigned short nItemNum;
	for (nItemNum = 0; nItemNum < LITCELLS_MAX_ITEMS ; nItemNum++)
	{
		CellInfo_t* pThisCell = &_nCellLitInfos[ nItemNum ];
		
		ASSERT(pThisCell->m_nLitLevel <= LITCELL_LITMAX);
		
		char nRandMax = 30 + 60*pThisCell->m_nLitLevel/LITCELL_LITMAX;
		if (rand()%100 < nRandMax)
		{
			SetLitCell_NewMovie(pThisCell);
			pThisCell->m_nAnimCurrentTime = rand()%( MAX(0,pThisCell->m_nAnimMaxTime) );
			
			if (rand()%2 == 0)
				pThisCell->m_nAnimMovieNum |= LITCELL_MOVIENUMFLG_REVERSE;
		}
		else
		{
			pThisCell->m_nAnimMovieNum = 64;
			pThisCell->m_nAnimCurrentTime = 0;
			pThisCell->m_nAnimMaxTime = 255;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*----------------------------- Draw Lit Cells ----------------------------*/
/*-------------------------------------------------------------------------*/
void DrawLitCells()
{
	float fx, fy;
	char nx, ny;
	
	fy = 0.5f*LITCELL_SPR_W;
	for (ny=0; ny < LITCELLS_MAX_ROWS; ny++)
	{
		fx = 0.5f*LITCELL_SPR_W;
		
		for (nx=0; nx < LITCELLS_MAX_COLS; nx++)
		{
			CellInfo_t* pThisCell = GetLitCellAt(nx, ny);
			
			float fAlphaSprite = 0.0f;
			float fAlphaRect = 0.0f;
			if (pThisCell->m_nLitLevel > LITCELL_LITMAX/2)
			{
				fAlphaSprite = 1.0f;
				fAlphaRect = 1.0f*(pThisCell->m_nLitLevel - LITCELL_LITMAX/2)/(0.55f*LITCELL_LITMAX);
				ASSERT(fAlphaRect < 1.0f);
			}
			else
			{
				fAlphaSprite = 1.0f*pThisCell->m_nLitLevel/(0.5f*LITCELL_LITMAX);
			}
			
			if (fAlphaRect > 0.0f)
			{
				DrawMonoQuad4f(fx, fy, LITCELL_SPR_W, LITCELL_SPR_W, 0.0f, 0.0f, 0.0f, fAlphaRect);
			}
			
			if (pThisCell->m_nAnimCurrentTime > 0)
			{
				if (fAlphaSprite > 0.0f)
				{
					unsigned short nMovieExternalId = MOVIEID_LITCELL0 + (pThisCell->m_nAnimMovieNum & LITCELL_MOVIENUM__MASK);
					unsigned char nSpriteNum = pThisCell->m_nAnimCurrentTime*LITCELL_MOVIE_MAXSPRITESANIM/(pThisCell->m_nAnimMaxTime+1);
					ASSERT(nSpriteNum < LITCELL_MOVIE_MAXSPRITESANIM);
					
					if ((pThisCell->m_nAnimMovieNum & LITCELL_MOVIENUMFLG_REVERSE) == 0)
					{
						nSpriteNum = LITCELL_MOVIE_MAXSPRITESANIM-1 - nSpriteNum;
					}
					
					CMovieClip* pClip = (CMovieClip*)_pListMovieClips->GetItemByExternalId(nMovieExternalId);
					ASSERT(pClip != NULL);
					pClip->Draw_w_h_NumImage(
						  fx, fy
						, LITCELL_SPR_W, LITCELL_SPR_W
						, 0, nSpriteNum
						, fAlphaSprite
						);
				}
				
			}
			
			fx += LITCELL_SPR_W;
		}
		
		fy += LITCELL_SPR_W;
	}
			
}


/*-------------------------------------------------------------------------*/
/*---------------------------- Move Mouse Cursor --------------------------*/
/*-------------------------------------------------------------------------*/
void MoveMouseCursor()
{
	// Logic
	
	if (_pMouseCtrl->IsPressedButton(0))
	{
		_nCursorLastPressFire = CURSORANIM_FIRE_BUMP_TIME;
		_nCursorRotTarget65536 += CURSORANIM_ADDROT_FIRE;
	}
	else if (_nCursorLastPressFire > 0)
		_nCursorLastPressFire--;
	


	// Cosmetics ////////////////////////////////////////////////////////////
	
	float fMouseAccelX, fMouseAccelY;
	_pMouseCtrl->GetMouseAccelXY(fMouseAccelX, fMouseAccelY);

	short nDiffPos =  abs(fMouseAccelX) + abs(fMouseAccelY);
	nDiffPos = MIN(16, nDiffPos);
	
	if (nDiffPos == 0)
	{
		nDiffPos = -2;
	}
	else
	{
		
	}
	
	int MOUSE_HALO_PERIOD = 550;
	float fMouseHaloRatioX =  0.7f + 0.3f*CalcAbsTriangle_Int(_pGameHelper->GetTotalExecutionTime()%MOUSE_HALO_PERIOD, 0, MOUSE_HALO_PERIOD);
	float fMouseHaloRatioY = 1.0f - 0.3f*fMouseHaloRatioX;

	UpdateLitCells(_pMouseCtrl->m_fX, _pMouseCtrl->m_fY, fMouseHaloRatioX, fMouseHaloRatioY);
	_nCursorRotVelocity += nDiffPos;
	_nCursorRotVelocity = CLAMP(0, _nCursorRotVelocity, CURSORANIM_KEEP_OLDPOS_MAX);

	short nAdd = CURSORANIM_ADDROT_IDLE + CURSORANIM_ADDROT_MOVE_MAX*_nCursorRotVelocity/CURSORANIM_KEEP_OLDPOS_MAX;
	_nCursorRotTarget65536 += nAdd;
	
	
	short nRotDiff = _nCursorRotTarget65536 - _nCursorRotCurrent65536;
	
	if (nRotDiff < 0 || nRotDiff >= CURSORANIM_ADDROT_SMOOTH)
	{
		_nCursorRotCurrent65536 += CURSORANIM_ADDROT_SMOOTH;
	}
	else if (nRotDiff > 0)
	{
		_nCursorRotCurrent65536 = _nCursorRotTarget65536;
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Draw Mouse Cursor --------------------------*/
/*-------------------------------------------------------------------------*/
void DrawMouseCursor()
{
	float fBumpPos = CalcCosineAccelDeccel_Int(_nCursorLastPressFire, 0, CURSORANIM_FIRE_BUMP_TIME);
	fBumpPos *= CalcLinear_Int(CURSORANIM_FIRE_BUMP_TIME-_nCursorLastPressFire, -1, 3);
	
	float fVelocityPos = CalcLinear_Int(_nCursorRotVelocity, 0, CURSORANIM_KEEP_OLDPOS_MAX);
	
	float fRectW = 4.0f + 20.0f*fBumpPos;
	float fRectH = 26.0f - 4.0f*fVelocityPos;
	fRectH = fRectH + fBumpPos*(16.0f - fRectH);
	float fRadius = 8.0f + 16.0f*fBumpPos + 0.5f*fRectH + 4.0f*fVelocityPos;
	float fAlpha = 0.6f + 0.4f*fBumpPos - 0.2f*fVelocityPos;
	
	fAlpha *= 0.87f;
	float fRot360 = 360.0f*_nCursorRotCurrent65536/65536.0f;

	// Setup the transformation
	ALLEGRO_TRANSFORM transform;
	al_identity_transform(&transform); 
	//if (scale != 1.0f) al_scale_transform(&transform, scale, scale); 
	al_rotate_transform(&transform, fRot360*M_PI/180.0f);
	al_translate_transform(&transform, _pMouseCtrl->m_fX, _pMouseCtrl->m_fY); 
	al_use_transform(&transform);
	
		DrawMonoQuad4f(       0, -fRadius,  fRectW, fRectH,  1.0f, 1.0f, 1.0f,  fAlpha);
		DrawMonoQuad4f( fRadius,        0,  fRectH, fRectW,  1.0f, 1.0f, 1.0f,  fAlpha);
		DrawMonoQuad4f(       0,  fRadius,  fRectW, fRectH,  1.0f, 1.0f, 1.0f,  fAlpha);
		DrawMonoQuad4f(-fRadius,        0,  fRectH, fRectW,  1.0f, 1.0f, 1.0f,  fAlpha);
	
	// Turn off the transformation
	al_identity_transform(&transform); 
	al_use_transform(&transform);

}

/*-------------------------------------------------------------------------*/
/*------------------------ Draw Background Grad Rect ----------------------*/
/*-------------------------------------------------------------------------*/
void DrawBackgroundGradRect(int nGradNum0, int nGradNum1, float fGrad01_Pos )
{
	short nBarH = 8;
	unsigned short MAX_GRAD_CURSOR = 600; // 512;
	short DROP_COL_EVERY = 64;
	
	short ny = nBarH/2;
	CGradient* pGrad0 = (CGradient*)_pListGradients->GetItem(nGradNum0);
	CGradient* pGrad1 = (CGradient*)_pListGradients->GetItem(nGradNum1);

	CGradient* pGradRed = (CGradient*)_pListGradients->GetItem(GRADNUM_BG_RED);
	float fRedFactor = (1.0f*PLAYER_NB_LIVES_BEGIN - _fGroundLimitDisplayedLives)/(1.0f*PLAYER_NB_LIVES_BEGIN);
	fRedFactor = CLAMP(0.0f, fRedFactor, 1.0f);
	
	unsigned short nBarPos = 0; 
	short nNextDrop = DROP_COL_EVERY/2; 
	char nColAdd = 7;
	float fr1, fg1, fb1;
	float fr0, fg0, fb0;

	while (ny < BITMAP_H)
	{
		nBarPos += nColAdd;
		nNextDrop -= nColAdd;
		if (nNextDrop <= 0)
		{
			nNextDrop += DROP_COL_EVERY;
			nBarPos -= (DROP_COL_EVERY/4);
		}
		
		float fGradPosY = CalcAbsTriangle_Int(nBarPos%MAX_GRAD_CURSOR, 0, MAX_GRAD_CURSOR-1);
		pGrad0->GetColor_3f(fGradPosY, &fr0,&fg0,&fb0);
		pGrad1->GetColor_3f(fGradPosY, &fr1,&fg1,&fb1);

		GetMidColor3f(fr0, fg0, fb0,  fr1, fg1, fb1,  fr0, fg0, fb0, fGrad01_Pos);

		pGradRed->GetColor_3f(fGradPosY, &fr1,&fg1,&fb1);
		GetMidColor3f(fr0, fg0, fb0,  fr1, fg1, fb1,  fr0, fg0, fb0, fRedFactor);

		DrawMonoQuad4f(0.5f*BITMAP_W, ny,  BITMAP_W, nBarH
			, fr0, fg0, fb0
			, 1.0f);

		// mytextprintf(0, ny-nBarH/2, "%.3f", fGradPos);

		ny += nBarH;
	}
}

/*-------------------------------------------------------------------------*/
/*------------------------ Draw Gradient Background -----------------------*/
/*-------------------------------------------------------------------------*/
void DrawColoredBackground()
{
	DrawMonoQuad4f(320, 240, 640, 480, 1,0,0, 1);

	int DAY_PERIOD = 120*FPS_EXPECTED;
	if (_nDayTime >= DAY_PERIOD)
	{
		_nDayTime = 0;
	}

	float fPos_TimeOfDay = GRADNUM_BG_DAY0 + 1.0f*(GRADNUM_BG_DAYMAX-GRADNUM_BG_DAY0+1)*_nDayTime/DAY_PERIOD;
	char nGradNum0 = (int)fPos_TimeOfDay;
	char nGradNum1 = nGradNum0+1;

	if (nGradNum1 > GRADNUM_BG_DAYMAX)
		nGradNum1 = GRADNUM_BG_DAY0;

	float fGradPos = fPos_TimeOfDay - (float)nGradNum0;

	DrawBackgroundGradRect(nGradNum0, nGradNum1, fGradPos);
}

/*-------------------------------------------------------------------------*/
/*------------------------ Draw Waves In Background -----------------------*/
/*-------------------------------------------------------------------------*/
void DrawWavesInBackground()
{
	for (int nWaveNum=0; nWaveNum < 2; nWaveNum++)
	{
		int NB_POINTS_PER_LINE = 48 - 16*nWaveNum;
		float fRectW = 4.0f + 4.0f*nWaveNum;

		for (int nItemNum=0; nItemNum < NB_POINTS_PER_LINE; nItemNum++)
		{
			float fAngle = 400.0f*nItemNum/NB_POINTS_PER_LINE + 360.0f*_nTotalExeTime/(2.0f*BEAT_PERIOD);
			fAngle *= (1.0f + nWaveNum);
			float fRadius = 16.0f;
			short fx = 0.25f*fRadius*get_dx_a360_hq(fAngle) + (0.5f+nItemNum)*BITMAP_W/NB_POINTS_PER_LINE;
			float fy = 1.00f*fRadius*get_dy_a360_hq(fAngle) + 0.5f*(CITY_YMIN + CITY_YMAX) - 32.0f*nWaveNum;
			DrawMonoQuad4f(fx, fy, fRectW, fRectW,  1.0f, 1.0f, 1.0f,  0.35f);
		}
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Draw Cursor Key ----------------------------*/
/*-------------------------------------------------------------------------*/
void DrawCursorKey(float fx, float fy, char nx, char ny, float fColVal, float fMouseAlpha)
{
	float fw = 32;
	float fBorderW = 8;
	float fSmallW = 8;

	DrawMonoQuad4f(fx, fy, fw+2.0f*fBorderW, fw+2.0f*fBorderW
		, 0.0f,0.0f,0.0f, 0.5f);

	DrawMonoQuad4f(fx, fy, fw, fw
		, fColVal,fColVal,fColVal, fMouseAlpha);

	DrawMonoQuad4f(
		  fx + nx*0.25f*fw
		, fy + ny*0.25f*fw
		, fSmallW, fSmallW
		, 0.0f,0.0f,0.0f, 0.7f*fMouseAlpha);
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Draw Demo HUD ----------------------------*/
/*-------------------------------------------------------------------------*/
void DrawDemoHUD()
{
	/*--- Draw Mouse ------------------------------------------------------*/

	float fx = 0.65f*BITMAP_W;
	float fy = 0.75f*BITMAP_H;

	float fBorderW = 8;
	float fMouseW = 80;
	float fMouseH = 140;
	float fColVal = 0.75f;
	float fMouseAlpha = 0.9f;

	DrawMonoQuad4f(fx, fy, fMouseW+2.0f*fBorderW, fMouseH+2.0f*fBorderW, 0.0f,0.0f,0.0f, 0.5f);

	float fClickBtn = (_nTotalExeTime%BEAT_PERIOD >= BEAT_PERIOD/2)? (0.25f*fColVal) : fColVal;
	DrawMonoQuad4f(
		  fx - 0.27f*fMouseW
		, fy - 0.30f*fMouseH
		, 0.48f*fMouseW
		, 0.40f*fMouseH
		, fClickBtn,fClickBtn,fClickBtn, fMouseAlpha);

	DrawMonoQuad4f(
		  fx + 0.27f*fMouseW
		, fy - 0.30f*fMouseH
		, 0.48f*fMouseW
		, 0.40f*fMouseH
		, fColVal,fColVal,fColVal, fMouseAlpha);

	DrawMonoQuad4f(
		  fx 
		, fy + 0.23f*fMouseH
		, fMouseW
		, 0.55f*fMouseH
		, fColVal,fColVal,fColVal, fMouseAlpha);


	/*--- Draw Cursors ----------------------------------------------------*/

	fx = BITMAP_W - fx;
	fy += 24;
	float fGridX = 56;

	DrawCursorKey(fx        , fy-fGridX,  0, -1, fColVal, fMouseAlpha);
	DrawCursorKey(fx        , fy       ,  0,  1, fColVal, fMouseAlpha);
	DrawCursorKey(fx-fGridX , fy       , -1,  0, fClickBtn, fMouseAlpha);
	DrawCursorKey(fx+fGridX , fy       ,  1,  0, fClickBtn, fMouseAlpha);

}
